libfuse: fuse_lowlevel_ops Struct Reference

libfuse

Data Fields
fuse_lowlevel_ops Struct Reference

`#include <fuse_lowlevel.h>`

## Data Fields
void(* | init )(void *userdata, struct fuse_conn_info *conn)
void(* | destroy )(void *userdata)
void(* | lookup )(fuse_req_t req, fuse_ino_t parent, const char *name)
void(* | forget )(fuse_req_t req, fuse_ino_t ino, uint64_t nlookup)
void(* | getattr )(fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi)
void(* | setattr )(fuse_req_t req, fuse_ino_t ino, struct stat *attr, int to_set, struct fuse_file_info *fi)
void(* | readlink )(fuse_req_t req, fuse_ino_t ino)
void(* | mknod )(fuse_req_t req, fuse_ino_t parent, const char *name, mode_t mode, dev_t rdev)
void(* | mkdir )(fuse_req_t req, fuse_ino_t parent, const char *name, mode_t mode)
void(* | unlink )(fuse_req_t req, fuse_ino_t parent, const char *name)
void(* | rmdir )(fuse_req_t req, fuse_ino_t parent, const char *name)
void(* | symlink )(fuse_req_t req, const char *link, fuse_ino_t parent, const char *name)
void(* | rename )(fuse_req_t req, fuse_ino_t parent, const char *name, fuse_ino_t newparent, const char *newname, unsigned int flags)
void(* | link )(fuse_req_t req, fuse_ino_t ino, fuse_ino_t newparent, const char *newname)
void(* | open )(fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi)
void(* | read )(fuse_req_t req, fuse_ino_t ino, size_t size, off_t off, struct fuse_file_info *fi)
void(* | write )(fuse_req_t req, fuse_ino_t ino, const char *buf, size_t size, off_t off, struct fuse_file_info *fi)
void(* | flush )(fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi)
void(* | release )(fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi)
void(* | fsync )(fuse_req_t req, fuse_ino_t ino, int datasync, struct fuse_file_info *fi)
void(* | opendir )(fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi)
void(* | readdir )(fuse_req_t req, fuse_ino_t ino, size_t size, off_t off, struct fuse_file_info *fi)
void(* | releasedir )(fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi)
void(* | fsyncdir )(fuse_req_t req, fuse_ino_t ino, int datasync, struct fuse_file_info *fi)
void(* | statfs )(fuse_req_t req, fuse_ino_t ino)
void(* | setxattr )(fuse_req_t req, fuse_ino_t ino, const char *name, const char *value, size_t size, int flags)
void(* | getxattr )(fuse_req_t req, fuse_ino_t ino, const char *name, size_t size)
void(* | listxattr )(fuse_req_t req, fuse_ino_t ino, size_t size)
void(* | removexattr )(fuse_req_t req, fuse_ino_t ino, const char *name)
void(* | access )(fuse_req_t req, fuse_ino_t ino, int mask)
void(* | create )(fuse_req_t req, fuse_ino_t parent, const char *name, mode_t mode, struct fuse_file_info *fi)
void(* | getlk )(fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi, struct flock *lock)
void(* | setlk )(fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi, struct flock *lock, int sleep)
void(* | bmap )(fuse_req_t req, fuse_ino_t ino, size_t blocksize, uint64_t idx)
void(* | ioctl )(fuse_req_t req, fuse_ino_t ino, unsigned int cmd, void *arg, struct fuse_file_info *fi, unsigned flags, const void *in_buf, size_t in_bufsz, size_t out_bufsz)
void(* | poll )(fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi, struct fuse_pollhandle *ph)
void(* | write_buf )(fuse_req_t req, fuse_ino_t ino, struct fuse_bufvec *bufv, off_t off, struct fuse_file_info *fi)
void(* | retrieve_reply )(fuse_req_t req, void *cookie, fuse_ino_t ino, off_t offset, struct fuse_bufvec *bufv)
void(* | forget_multi )(fuse_req_t req, size_t count, struct fuse_forget_data *forgets)
void(* | flock )(fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi, int op)
void(* | fallocate )(fuse_req_t req, fuse_ino_t ino, int mode, off_t offset, off_t length, struct fuse_file_info *fi)
void(* | readdirplus )(fuse_req_t req, fuse_ino_t ino, size_t size, off_t off, struct fuse_file_info *fi)
void(* | copy_file_range )(fuse_req_t req, fuse_ino_t ino_in, off_t off_in, struct fuse_file_info *fi_in, fuse_ino_t ino_out, off_t off_out, struct fuse_file_info *fi_out, size_t len, int flags)
void(* | lseek )(fuse_req_t req, fuse_ino_t ino, off_t off, int whence, struct fuse_file_info *fi)

## Detailed Description

Low level filesystem operations

Most of the methods (with the exception of init and destroy) receive a request handle (fuse_req_t) as their first argument. This handle must be passed to one of the specified reply functions.

This may be done inside the method invocation, or after the call has returned. The request handle is valid until one of the reply functions is called.

Other pointer arguments (name, fuse_file_info, etc) are not valid after the call has returned, so if they are needed later, their contents have to be copied.

In general, all methods are expected to perform any necessary permission checking. However, a filesystem may delegate this task to the kernel by passing the `default_permissions` mount option to `fuse_session_new()`. In this case, methods will only be called if the kernel's permission check has succeeded.

The filesystem sometimes needs to handle a return value of -ENOENT from the reply function, which means, that the request was interrupted, and the reply discarded. For example if fuse_reply_open() return -ENOENT means, that the release method for this file will not be called.

Definition at line 201 of file fuse_lowlevel.h.

## Field Documentation

## ◆ access

void(* fuse_lowlevel_ops::access) (fuse_req_t req, fuse_ino_t ino, int mask)

Check file access permissions

This will be called for the access() and chdir() system calls. If the 'default_permissions' mount option is given, this method is not called.

This method is not called under Linux kernel versions 2.4.x

If this request is answered with an error code of ENOSYS, this is treated as a permanent success, i.e. this and all future access() requests will succeed without being send to the filesystem process.

Valid replies: fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  mask | requested access mode

Definition at line 932 of file fuse_lowlevel.h.

## ◆ bmap

void(* fuse_lowlevel_ops::bmap) (fuse_req_t req, fuse_ino_t ino, size_t blocksize, uint64_t idx)

Map block index within file to block index within device

Note: This makes sense only for block device backed filesystems mounted with the 'blkdev' option

If this request is answered with an error code of ENOSYS, this is treated as a permanent failure, i.e. all future bmap() requests will fail with the same error code without being send to the filesystem process.

Valid replies: fuse_reply_bmap fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  blocksize | unit of block index
  idx | block index within file

Definition at line 1025 of file fuse_lowlevel.h.

## ◆ copy_file_range

void(* fuse_lowlevel_ops::copy_file_range) (fuse_req_t req, fuse_ino_t ino_in, off_t off_in, struct fuse_file_info *fi_in, fuse_ino_t ino_out, off_t off_out, struct fuse_file_info *fi_out, size_t len, int flags)

Copy a range of data from one file to another

Performs an optimized copy between two file descriptors without the additional cost of transferring data through the FUSE kernel module to user space (glibc) and then back into the FUSE filesystem again.

In case this method is not implemented, glibc falls back to reading data from the source and writing to the destination. Effectively doing an inefficient copy of the data.

If this request is answered with an error code of ENOSYS, this is treated as a permanent failure with error code EOPNOTSUPP, i.e. all future copy_file_range() requests will fail with EOPNOTSUPP without being send to the filesystem process.

Valid replies: fuse_reply_write fuse_reply_err

Parameters

  req | request handle
  ino_in | the inode number or the source file
  off_in | starting point from were the data should be read
  fi_in | file information of the source file
  ino_out | the inode number or the destination file
  off_out | starting point where the data should be written
  fi_out | file information of the destination file
  len | maximum size of the data to copy
  flags | passed along with the copy_file_range() syscall

Definition at line 1257 of file fuse_lowlevel.h.

## ◆ create

void(* fuse_lowlevel_ops::create) (fuse_req_t req, fuse_ino_t parent, const char *name, mode_t mode, struct fuse_file_info *fi)

Create and open a file

If the file does not exist, first create it with the specified mode, and then open it.

See the description of the open handler for more information.

If this method is not implemented or under Linux kernel versions earlier than 2.6.15, the mknod() and open() methods will be called instead.

If this request is answered with an error code of ENOSYS, the handler is treated as not implemented (i.e., for this and future requests the mknod() and open() handlers will be called instead).

Valid replies: fuse_reply_create fuse_reply_err

Parameters

  req | request handle
  parent | inode number of the parent directory
  name | to create
  mode | file type and mode with which to create the new file
  fi | file information

Definition at line 961 of file fuse_lowlevel.h.

## ◆ destroy

void(* fuse_lowlevel_ops::destroy) (void *userdata)

Clean up filesystem.

Called on filesystem exit. When this method is called, the connection to the kernel may be gone already, so that eg. calls to fuse_lowlevel_notify_* will fail.

There's no reply to this function

Parameters

  userdata | the user data passed to fuse_session_new()

Definition at line 231 of file fuse_lowlevel.h.

## ◆ fallocate

void(* fuse_lowlevel_ops::fallocate) (fuse_req_t req, fuse_ino_t ino, int mode, off_t offset, off_t length, struct fuse_file_info *fi)

Allocate requested space. If this function returns success then subsequent writes to the specified range shall not fail due to the lack of free space on the file system storage media.

If this request is answered with an error code of ENOSYS, this is treated as a permanent failure with error code EOPNOTSUPP, i.e. all future fallocate() requests will fail with EOPNOTSUPP without being send to the filesystem process.

Valid replies: fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  offset | starting point for allocated region
  length | size of allocated region
  mode | determines the operation to be performed on the given range, see fallocate(2)

Definition at line 1196 of file fuse_lowlevel.h.

## ◆ flock

void(* fuse_lowlevel_ops::flock) (fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi, int op)

Acquire, modify or release a BSD file lock

Note: if the locking methods are not implemented, the kernel will still allow file locking to work locally. Hence these are only interesting for network filesystems and similar.

Valid replies: fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  fi | file information
  op | the locking operation, see flock(2)

Definition at line 1173 of file fuse_lowlevel.h.

## ◆ flush

void(* fuse_lowlevel_ops::flush) (fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi)

Flush method

This is called on each close() of the opened file.

Since file descriptors can be duplicated (dup, dup2, fork), for one open call there may be many flush calls.

Filesystems shouldn't assume that flush will always be called after some writes, or that if will be called at all.

fi->fh will contain the value set by the open method, or will be undefined if the open method didn't set any value.

NOTE: the name of the method is misleading, since (unlike fsync) the filesystem is not forced to flush pending writes. One reason to flush data is if the filesystem wants to return write errors during close. However, such use is non-portable because POSIX does not require close to wait for delayed I/O to complete.

If the filesystem supports file locking operations (setlk, getlk) it should remove all locks belonging to 'fi->owner'.

If this request is answered with an error code of ENOSYS, this is treated as success and future calls to flush() will succeed automatically without being send to the filesystem process.

Valid replies: fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  fi | file information

Definition at line 640 of file fuse_lowlevel.h.

## ◆ forget

void(* fuse_lowlevel_ops::forget) (fuse_req_t req, fuse_ino_t ino, uint64_t nlookup)

Forget about an inode

This function is called when the kernel removes an inode from its internal caches.

The inode's lookup count increases by one for every call to fuse_reply_entry and fuse_reply_create. The nlookup parameter indicates by how much the lookup count should be decreased.

Inodes with a non-zero lookup count may receive request from the kernel even after calls to unlink, rmdir or (when overwriting an existing file) rename. Filesystems must handle such requests properly and it is recommended to defer removal of the inode until the lookup count reaches zero. Calls to unlink, rmdir or rename will be followed closely by forget unless the file or directory is open, in which case the kernel issues forget only after the release or releasedir calls.

Note that if a file system will be exported over NFS the inodes lifetime must extend even beyond forget. See the generation field in struct fuse_entry_param above.

On unmount the lookup count for all inodes implicitly drops to zero. It is not guaranteed that the file system will receive corresponding forget messages for the affected inodes.

Valid replies: fuse_reply_none

Parameters

  req | request handle
  ino | the inode number
  nlookup | the number of lookups to forget

Definition at line 282 of file fuse_lowlevel.h.

## ◆ forget_multi

void(* fuse_lowlevel_ops::forget_multi) (fuse_req_t req, size_t count, struct fuse_forget_data *forgets)

Forget about multiple inodes

See description of the forget function for more information.

Valid replies: fuse_reply_none

Parameters

  req | request handle

Definition at line 1155 of file fuse_lowlevel.h.

## ◆ fsync

void(* fuse_lowlevel_ops::fsync) (fuse_req_t req, fuse_ino_t ino, int datasync, struct fuse_file_info *fi)

Synchronize file contents

If the datasync parameter is non-zero, then only the user data should be flushed, not the meta data.

If this request is answered with an error code of ENOSYS, this is treated as success and future calls to fsync() will succeed automatically without being send to the filesystem process.

Valid replies: fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  datasync | flag indicating if only data should be flushed
  fi | file information

Definition at line 690 of file fuse_lowlevel.h.

## ◆ fsyncdir

void(* fuse_lowlevel_ops::fsyncdir) (fuse_req_t req, fuse_ino_t ino, int datasync, struct fuse_file_info *fi)

Synchronize directory contents

If the datasync parameter is non-zero, then only the directory contents should be flushed, not the meta data.

fi->fh will contain the value set by the opendir method, or will be undefined if the opendir method didn't set any value.

If this request is answered with an error code of ENOSYS, this is treated as success and future calls to fsyncdir() will succeed automatically without being send to the filesystem process.

Valid replies: fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  datasync | flag indicating if only data should be flushed
  fi | file information

Definition at line 805 of file fuse_lowlevel.h.

## ◆ getattr

void(* fuse_lowlevel_ops::getattr) (fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi)

Get file attributes.

If writeback caching is enabled, the kernel may have a better idea of a file's length than the FUSE file system (eg if there has been a write that extended the file size, but that has not yet been passed to the filesystem.n

In this case, the st_size value provided by the file system will be ignored.

Valid replies: fuse_reply_attr fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  fi | for future use, currently always NULL

Definition at line 303 of file fuse_lowlevel.h.

## ◆ getlk

void(* fuse_lowlevel_ops::getlk) (fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi, struct flock *lock)

Test for a POSIX file lock

Valid replies: fuse_reply_lock fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  fi | file information
  lock | the region/type to test

Definition at line 976 of file fuse_lowlevel.h.

## ◆ getxattr

void(* fuse_lowlevel_ops::getxattr) (fuse_req_t req, fuse_ino_t ino, const char *name, size_t size)

Get an extended attribute

If size is zero, the size of the value should be sent with fuse_reply_xattr.

If the size is non-zero, and the value fits in the buffer, the value should be sent with fuse_reply_buf.

If the size is too small for the value, the ERANGE error should be sent.

If this request is answered with an error code of ENOSYS, this is treated as a permanent failure with error code EOPNOTSUPP, i.e. all future getxattr() requests will fail with EOPNOTSUPP without being send to the filesystem process.

Valid replies: fuse_reply_buf fuse_reply_data fuse_reply_xattr fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  name | of the extended attribute
  size | maximum size of the value to send

Definition at line 862 of file fuse_lowlevel.h.

## ◆ init

void(* fuse_lowlevel_ops::init) (void *userdata, struct fuse_conn_info *conn)

Initialize filesystem

This function is called when libfuse establishes communication with the FUSE kernel module. The file system should use this module to inspect and/or modify the connection parameters provided in the `conn` structure.

Note that some parameters may be overwritten by options passed to fuse_session_new() which take precedence over the values set in this handler.

There's no reply to this function

Parameters

  userdata | the user data passed to fuse_session_new()

Definition at line 218 of file fuse_lowlevel.h.

## ◆ ioctl

void(* fuse_lowlevel_ops::ioctl) (fuse_req_t req, fuse_ino_t ino, unsigned int cmd, void *arg, struct fuse_file_info *fi, unsigned flags, const void *in_buf, size_t in_bufsz, size_t out_bufsz)

Ioctl

Note: For unrestricted ioctls (not allowed for FUSE servers), data in and out areas can be discovered by giving iovs and setting FUSE_IOCTL_RETRY in flags. For restricted ioctls, kernel prepares in/out data area according to the information encoded in cmd.

Valid replies: fuse_reply_ioctl_retry fuse_reply_ioctl fuse_reply_ioctl_iov fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  cmd | ioctl command
  arg | ioctl argument
  fi | file information
  flags | for FUSE_IOCTL_* flags
  in_buf | data fetched from the caller
  in_bufsz | number of fetched bytes
  out_bufsz | maximum size of output data

Note : the unsigned long request submitted by the application is truncated to 32 bits.

Definition at line 1061 of file fuse_lowlevel.h.

## ◆ link

void(* fuse_lowlevel_ops::link) (fuse_req_t req, fuse_ino_t ino, fuse_ino_t newparent, const char *newname)

Create a hard link

Valid replies: fuse_reply_entry fuse_reply_err

Parameters

  req | request handle
  ino | the old inode number
  newparent | inode number of the new parent directory
  newname | new name to create

Definition at line 483 of file fuse_lowlevel.h.

## ◆ listxattr

void(* fuse_lowlevel_ops::listxattr) (fuse_req_t req, fuse_ino_t ino, size_t size)

List extended attribute names

If size is zero, the total size of the attribute list should be sent with fuse_reply_xattr.

If the size is non-zero, and the null character separated attribute list fits in the buffer, the list should be sent with fuse_reply_buf.

If the size is too small for the list, the ERANGE error should be sent.

If this request is answered with an error code of ENOSYS, this is treated as a permanent failure with error code EOPNOTSUPP, i.e. all future listxattr() requests will fail with EOPNOTSUPP without being send to the filesystem process.

Valid replies: fuse_reply_buf fuse_reply_data fuse_reply_xattr fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  size | maximum size of the list to send

Definition at line 893 of file fuse_lowlevel.h.

## ◆ lookup

void(* fuse_lowlevel_ops::lookup) (fuse_req_t req, fuse_ino_t parent, const char *name)

Look up a directory entry by name and get its attributes.

Valid replies: fuse_reply_entry fuse_reply_err

Parameters

  req | request handle
  parent | inode number of the parent directory
  name | the name to look up

Definition at line 244 of file fuse_lowlevel.h.

## ◆ lseek

void(* fuse_lowlevel_ops::lseek) (fuse_req_t req, fuse_ino_t ino, off_t off, int whence, struct fuse_file_info *fi)

Find next data or hole after the specified offset

If this request is answered with an error code of ENOSYS, this is treated as a permanent failure, i.e. all future lseek() requests will fail with the same error code without being send to the filesystem process.

Valid replies: fuse_reply_lseek fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  off | offset to start search from
  whence | either SEEK_DATA or SEEK_HOLE
  fi | file information

Definition at line 1281 of file fuse_lowlevel.h.

## ◆ mkdir

void(* fuse_lowlevel_ops::mkdir) (fuse_req_t req, fuse_ino_t parent, const char *name, mode_t mode)

Create a directory

Valid replies: fuse_reply_entry fuse_reply_err

Parameters

  req | request handle
  parent | inode number of the parent directory
  name | to create
  mode | with which to create the new file

Definition at line 386 of file fuse_lowlevel.h.

## ◆ mknod

void(* fuse_lowlevel_ops::mknod) (fuse_req_t req, fuse_ino_t parent, const char *name, mode_t mode, dev_t rdev)

Create file node

Create a regular file, character device, block device, fifo or socket node.

Valid replies: fuse_reply_entry fuse_reply_err

Parameters

  req | request handle
  parent | inode number of the parent directory
  name | to create
  mode | file type and mode with which to create the new file
  rdev | the device number (only valid if created file is a device)

Definition at line 371 of file fuse_lowlevel.h.

## ◆ open

void(* fuse_lowlevel_ops::open) (fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi)

Open a file

Open flags are available in fi->flags. The following rules apply.

- Creation (O_CREAT, O_EXCL, O_NOCTTY) flags will be filtered out / handled by the kernel.
- Access modes (O_RDONLY, O_WRONLY, O_RDWR) should be used by the filesystem to check if the operation is permitted. If the `-o default_permissions` mount option is given, this check is already done by the kernel before calling open() and may thus be omitted by the filesystem.
- When writeback caching is enabled, the kernel may send read requests even for files opened with O_WRONLY. The filesystem should be prepared to handle this.
- When writeback caching is disabled, the filesystem is expected to properly handle the O_APPEND flag and ensure that each write is appending to the end of the file.
- When writeback caching is enabled, the kernel will handle O_APPEND. However, unless all changes to the file come through the kernel this will not work reliably. The filesystem should thus either ignore the O_APPEND flag (and let the kernel handle it), or return an error (indicating that reliably O_APPEND is not available).

Filesystem may store an arbitrary file handle (pointer, index, etc) in fi->fh, and use this in other all other file operations (read, write, flush, release, fsync).

Filesystem may also implement stateless file I/O and not store anything in fi->fh.

There are also some flags (direct_io, keep_cache) which the filesystem may set in fi, to change the way the file is opened. See fuse_file_info structure in <fuse_common.h> for more details.

If this request is answered with an error code of ENOSYS and FUSE_CAP_NO_OPEN_SUPPORT is set in `fuse_conn_info.capable`, this is treated as success and future calls to open and release will also succeed without being sent to the filesystem process.

Valid replies: fuse_reply_open fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  fi | file information

Definition at line 542 of file fuse_lowlevel.h.

## ◆ opendir

void(* fuse_lowlevel_ops::opendir) (fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi)

Open a directory

Filesystem may store an arbitrary file handle (pointer, index, etc) in fi->fh, and use this in other all other directory stream operations (readdir, releasedir, fsyncdir).

If this request is answered with an error code of ENOSYS and FUSE_CAP_NO_OPENDIR_SUPPORT is set in `fuse_conn_info.capable`, this is treated as success and future calls to opendir and releasedir will also succeed without being sent to the filesystem process. In addition, the kernel will cache readdir results as if opendir returned FOPEN_KEEP_CACHE | FOPEN_CACHE_DIR.

Valid replies: fuse_reply_open fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  fi | file information

Definition at line 715 of file fuse_lowlevel.h.

## ◆ poll

void(* fuse_lowlevel_ops::poll) (fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi, struct fuse_pollhandle *ph)

Poll for IO readiness

Note: If ph is non-NULL, the client should notify when IO readiness events occur by calling fuse_lowlevel_notify_poll() with the specified ph.

Regardless of the number of times poll with a non-NULL ph is received, single notification is enough to clear all. Notifying more times incurs overhead but doesn't harm correctness.

The callee is responsible for destroying ph with fuse_pollhandle_destroy() when no longer in use.

If this request is answered with an error code of ENOSYS, this is treated as success (with a kernel-defined default poll-mask) and future calls to pull() will succeed the same way without being send to the filesystem process.

Valid replies: fuse_reply_poll fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  fi | file information
  ph | poll handle to be used for notification

Definition at line 1095 of file fuse_lowlevel.h.

## ◆ read

void(* fuse_lowlevel_ops::read) (fuse_req_t req, fuse_ino_t ino, size_t size, off_t off, struct fuse_file_info *fi)

Read data

Read should send exactly the number of bytes requested except on EOF or error, otherwise the rest of the data will be substituted with zeroes. An exception to this is when the file has been opened in 'direct_io' mode, in which case the return value of the read system call will reflect the return value of this operation.

fi->fh will contain the value set by the open method, or will be undefined if the open method didn't set any value.

Valid replies: fuse_reply_buf fuse_reply_iov fuse_reply_data fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  size | number of bytes to read
  off | offset to read from
  fi | file information

Definition at line 570 of file fuse_lowlevel.h.

## ◆ readdir

void(* fuse_lowlevel_ops::readdir) (fuse_req_t req, fuse_ino_t ino, size_t size, off_t off, struct fuse_file_info *fi)

Read directory

Send a buffer filled using fuse_add_direntry(), with size not exceeding the requested size. Send an empty buffer on end of stream.

fi->fh will contain the value set by the opendir method, or will be undefined if the opendir method didn't set any value.

Returning a directory entry from readdir() does not affect its lookup count.

If off_t is non-zero, then it will correspond to one of the off_t values that was previously returned by readdir() for the same directory handle. In this case, readdir() should skip over entries coming before the position defined by the off_t value. If entries are added or removed while the directory handle is open, the filesystem may still include the entries that have been removed, and may not report the entries that have been created. However, addition or removal of entries must never cause readdir() to skip over unrelated entries or to report them more than once. This means that off_t can not be a simple index that enumerates the entries that have been returned but must contain sufficient information to uniquely determine the next directory entry to return even when the set of entries is changing.

The function does not have to report the '.' and '..' entries, but is allowed to do so. Note that, if readdir does not return '.' or '..', they will not be implicitly returned, and this behavior is observable by the caller.

Valid replies: fuse_reply_buf fuse_reply_data fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  size | maximum number of bytes to send
  off | offset to continue reading the directory stream
  fi | file information

Definition at line 761 of file fuse_lowlevel.h.

## ◆ readdirplus

void(* fuse_lowlevel_ops::readdirplus) (fuse_req_t req, fuse_ino_t ino, size_t size, off_t off, struct fuse_file_info *fi)

Read directory with attributes

Send a buffer filled using fuse_add_direntry_plus(), with size not exceeding the requested size. Send an empty buffer on end of stream.

fi->fh will contain the value set by the opendir method, or will be undefined if the opendir method didn't set any value.

In contrast to readdir() (which does not affect the lookup counts), the lookup count of every entry returned by readdirplus(), except "." and "..", is incremented by one.

Valid replies: fuse_reply_buf fuse_reply_data fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  size | maximum number of bytes to send
  off | offset to continue reading the directory stream
  fi | file information

Definition at line 1224 of file fuse_lowlevel.h.

## ◆ readlink

void(* fuse_lowlevel_ops::readlink) (fuse_req_t req, fuse_ino_t ino)

Read symbolic link

Valid replies: fuse_reply_readlink fuse_reply_err

Parameters

  req | request handle
  ino | the inode number

Definition at line 353 of file fuse_lowlevel.h.

## ◆ release

void(* fuse_lowlevel_ops::release) (fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi)

Release an open file

Release is called when there are no more references to an open file: all file descriptors are closed and all memory mappings are unmapped.

For every open call there will be exactly one release call (unless the filesystem is force-unmounted).

The filesystem may reply with an error, but error values are not returned to close() or munmap() which triggered the release.

fi->fh will contain the value set by the open method, or will be undefined if the open method didn't set any value. fi->flags will contain the same flags as for open.

Valid replies: fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  fi | file information

Definition at line 668 of file fuse_lowlevel.h.

## ◆ releasedir

void(* fuse_lowlevel_ops::releasedir) (fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi)

Release an open directory

For every opendir call there will be exactly one releasedir call (unless the filesystem is force-unmounted).

fi->fh will contain the value set by the opendir method, or will be undefined if the opendir method didn't set any value.

Valid replies: fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  fi | file information

Definition at line 780 of file fuse_lowlevel.h.

## ◆ removexattr

void(* fuse_lowlevel_ops::removexattr) (fuse_req_t req, fuse_ino_t ino, const char *name)

Remove an extended attribute

If this request is answered with an error code of ENOSYS, this is treated as a permanent failure with error code EOPNOTSUPP, i.e. all future removexattr() requests will fail with EOPNOTSUPP without being send to the filesystem process.

Valid replies: fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  name | of the extended attribute

Definition at line 910 of file fuse_lowlevel.h.

## ◆ rename

void(* fuse_lowlevel_ops::rename) (fuse_req_t req, fuse_ino_t parent, const char *name, fuse_ino_t newparent, const char *newname, unsigned int flags)

Rename a file

If the target exists it should be atomically replaced. If the target's inode's lookup count is non-zero, the file system is expected to postpone any removal of the inode until the lookup count reaches zero (see description of the forget function).

If this request is answered with an error code of ENOSYS, this is treated as a permanent failure with error code EINVAL, i.e. all future bmap requests will fail with EINVAL without being send to the filesystem process.

flags may be `RENAME_EXCHANGE` or `RENAME_NOREPLACE`. If RENAME_NOREPLACE is specified, the filesystem must not overwrite newname if it exists and return an error instead. If `RENAME_EXCHANGE` is specified, the filesystem must atomically exchange the two files, i.e. both must exist and neither may be deleted.

Valid replies: fuse_reply_err

Parameters

  req | request handle
  parent | inode number of the old parent directory
  name | old name
  newparent | inode number of the new parent directory
  newname | new name

Definition at line 467 of file fuse_lowlevel.h.

## ◆ retrieve_reply

void(* fuse_lowlevel_ops::retrieve_reply) (fuse_req_t req, void *cookie, fuse_ino_t ino, off_t offset, struct fuse_bufvec *bufv)

Callback function for the retrieve request

Valid replies: fuse_reply_none

Parameters

  req | request handle
  cookie | user data supplied to fuse_lowlevel_notify_retrieve()
  ino | the inode number supplied to fuse_lowlevel_notify_retrieve()
  offset | the offset supplied to fuse_lowlevel_notify_retrieve()
  bufv | the buffer containing the returned data

Definition at line 1141 of file fuse_lowlevel.h.

## ◆ rmdir

void(* fuse_lowlevel_ops::rmdir) (fuse_req_t req, fuse_ino_t parent, const char *name)

Remove a directory

If the directory's inode's lookup count is non-zero, the file system is expected to postpone any removal of the inode until the lookup count reaches zero (see description of the forget function).

Valid replies: fuse_reply_err

Parameters

  req | request handle
  parent | inode number of the parent directory
  name | to remove

Definition at line 421 of file fuse_lowlevel.h.

## ◆ setattr

void(* fuse_lowlevel_ops::setattr) (fuse_req_t req, fuse_ino_t ino, struct stat *attr, int to_set, struct fuse_file_info *fi)

Set file attributes

In the 'attr' argument only members indicated by the 'to_set' bitmask contain valid values. Other members contain undefined values.

Unless FUSE_CAP_HANDLE_KILLPRIV is disabled, this method is expected to reset the setuid and setgid bits if the file size or owner is being changed.

This method will not be called to update st_atime or st_ctime implicitly (eg. after a read() request), and only be called to implicitly update st_mtime if writeback caching is active. It is the filesystem's responsibility to update these timestamps when needed, and (if desired) to implement mount options like `noatime` or `relatime`.

If the setattr was invoked from the ftruncate() system call under Linux kernel versions 2.6.15 or later, the fi->fh will contain the value set by the open method or will be undefined if the open method didn't set any value. Otherwise (not ftruncate call, or kernel version earlier than 2.6.15) the fi parameter will be NULL.

Valid replies: fuse_reply_attr fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  attr | the attributes
  to_set | bit mask of attributes which should be set
  fi | file information, or NULL

Definition at line 340 of file fuse_lowlevel.h.

## ◆ setlk

void(* fuse_lowlevel_ops::setlk) (fuse_req_t req, fuse_ino_t ino, struct fuse_file_info *fi, struct flock *lock, int sleep)

Acquire, modify or release a POSIX file lock

For POSIX threads (NPTL) there's a 1-1 relation between pid and owner, but otherwise this is not always the case. For checking lock ownership, 'fi->owner' must be used. The l_pid field in 'struct flock' should only be used to fill in this field in getlk().

Note: if the locking methods are not implemented, the kernel will still allow file locking to work locally. Hence these are only interesting for network filesystems and similar.

Valid replies: fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  fi | file information
  lock | the region/type to set
  sleep | locking operation may sleep

Definition at line 1001 of file fuse_lowlevel.h.

## ◆ setxattr

void(* fuse_lowlevel_ops::setxattr) (fuse_req_t req, fuse_ino_t ino, const char *name, const char *value, size_t size, int flags)

Set an extended attribute

If this request is answered with an error code of ENOSYS, this is treated as a permanent failure with error code EOPNOTSUPP, i.e. all future setxattr() requests will fail with EOPNOTSUPP without being send to the filesystem process.

Valid replies: fuse_reply_err

Definition at line 831 of file fuse_lowlevel.h.

## ◆ statfs

void(* fuse_lowlevel_ops::statfs) (fuse_req_t req, fuse_ino_t ino)

Get file system statistics

Valid replies: fuse_reply_statfs fuse_reply_err

Parameters

  req | request handle
  ino | the inode number, zero means "undefined"

Definition at line 818 of file fuse_lowlevel.h.

## ◆ symlink

void(* fuse_lowlevel_ops::symlink) (fuse_req_t req, const char *link, fuse_ino_t parent, const char *name)

Create a symbolic link

Valid replies: fuse_reply_entry fuse_reply_err

Parameters

  req | request handle
  link | the contents of the symbolic link
  parent | inode number of the parent directory
  name | to create

Definition at line 435 of file fuse_lowlevel.h.

## ◆ unlink

void(* fuse_lowlevel_ops::unlink) (fuse_req_t req, fuse_ino_t parent, const char *name)

Remove a file

If the file's inode's lookup count is non-zero, the file system is expected to postpone any removal of the inode until the lookup count reaches zero (see description of the forget function).

Valid replies: fuse_reply_err

Parameters

  req | request handle
  parent | inode number of the parent directory
  name | to remove

Definition at line 404 of file fuse_lowlevel.h.

## ◆ write

void(* fuse_lowlevel_ops::write) (fuse_req_t req, fuse_ino_t ino, const char *buf, size_t size, off_t off, struct fuse_file_info *fi)

Write data

Write should return exactly the number of bytes requested except on error. An exception to this is when the file has been opened in 'direct_io' mode, in which case the return value of the write system call will reflect the return value of this operation.

Unless FUSE_CAP_HANDLE_KILLPRIV is disabled, this method is expected to reset the setuid and setgid bits.

fi->fh will contain the value set by the open method, or will be undefined if the open method didn't set any value.

Valid replies: fuse_reply_write fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  buf | data to write
  size | number of bytes to write
  off | offset to write to
  fi | file information

Definition at line 599 of file fuse_lowlevel.h.

## ◆ write_buf

void(* fuse_lowlevel_ops::write_buf) (fuse_req_t req, fuse_ino_t ino, struct fuse_bufvec *bufv, off_t off, struct fuse_file_info *fi)

Write data made available in a buffer

This is a more generic version of the ->write() method. If FUSE_CAP_SPLICE_READ is set in fuse_conn_info.want and the kernel supports splicing from the fuse device, then the data will be made available in pipe for supporting zero copy data transfer.

buf->count is guaranteed to be one (and thus buf->idx is always zero). The write_buf handler must ensure that bufv->off is correctly updated (reflecting the number of bytes read from bufv->buf[0]).

Unless FUSE_CAP_HANDLE_KILLPRIV is disabled, this method is expected to reset the setuid and setgid bits.

Valid replies: fuse_reply_write fuse_reply_err

Parameters

  req | request handle
  ino | the inode number
  bufv | buffer containing the data
  off | offset to write to
  fi | file information

Definition at line 1125 of file fuse_lowlevel.h.

The documentation for this struct was generated from the following file:

- include/fuse_lowlevel.h